<?php
if(!isset($config))
	die();

// modified from wordpress - used for running actions afte certain events

$actions=array();

function add_action($tag,$function_to_add,$priority=10,$accepted_args=1){ // modified from wordpress - used for adding actions to events
	global $actions;
	$idx=action_id($tag,$function_to_add,$priority);
	$actions[$tag][$priority][$idx]=array('function'=>$function_to_add,'accepted_args'=>$accepted_args);
	return true;
}

function do_action($tag,$arg=''){
	global $actions;
	$action=array();
	$action[]=$tag;
	if(!isset($actions[$tag])){
		array_pop($action);
		return;
	}
	$args=array();
	if(is_array($arg)&&1==count($arg)&&is_object($arg[0]))
		$args[]=&$arg[0];
	else
		$args[]=$arg;
	for($a=2;$a<func_num_args();$a++)
		$args[]=func_get_arg($a);
	ksort($actions[$tag]);
	reset($actions[$tag]);
	do{
		foreach((array)current($actions[$tag]) as $the_)
			if(!is_null($the_['function']))
				call_user_func_array($the_['function'],array_slice($args,0,(int)$the_['accepted_args']));
	}while(next($actions[$tag])!==false);
	array_pop($action);
}

function action_id($tag,$function,$priority){ // modified from wordpress - used privately by add_action
	global $actions;
	if(is_string($function))
		return $function;
	else if(is_object($function[0])){
		$obj_idx=get_class($function[0]).$function[1];
		if(!isset($function[0]->action_id)){
			if(false===$priority)
				return false;
			$count=isset($actions[$tag][$priority])?count((array)$actions[$tag][$priority]):0;
			$function[0]->action_id=$count;
			$obj_idx.=$count;
			unset($count);
		}else
			$obj_idx.=$function[0]->action_id;
		return $obj_idx;
	}
	else if(is_string($function[0]))
		return $function[0].$function[1];
}
?>