<?php
if(!isset($config))
	die();

require_once('db.functions.php');
require_once('plugin.functions.php');
require_once('functions.php');
require_once('extend.php');

// other random shit that is commonly used

function nonce($str='',$expires=300){ // generates a secure nonce
	global $config;
	return md5(date('Y-m-d H:i',ceil(time()/$expires)*$expires).$_SERVER['REMOTE_ADDR'].$_SERVER['HTTP_USER_AGENT'].$config['password']['salt'].$str);
}

function sendmail($to,$subject,$body){ // sends an html email
	global $config;
	$headers='MIME-Version: 1.0'."\r\n";
	$headers.='Content-type: text/html; charset=iso-8859-1'."\r\n";
	$headers.='From: '.$config['site']['name'].' <'.$config['site']['email'].'>'."\r\n";
	return @mail($to,$subject,parse_template('email/html-dtd',array('title'=>$subject,'body'=>$body),false),$headers);
}

function parse_template($file,$data='',$echo=true){ // prepares and parses a template
	global $config,$db,$image,$stats;
	if(is_bool($data)){
		$echo=$data;
		unset($data);
	}
	if($data)
		foreach($data AS $d=>$v){
			if(!is_numeric($d))
				$$d=$v;
			else
				global $$v;
		}
	ob_start();
	require('templates/'.$file.'.php');
	$template=ob_get_contents();
	ob_end_clean();
	if(!$echo)
		return $template;
	echo $template;
}

function get_meta($key,$id,$table='user'){ // returns a meta value
	global $db;
	return $db->get_var($db->prepare("SELECT `value` FROM ".$table."meta WHERE `key`=%s AND $table=%d",$key,$id));
}

function get_meta_id($key,$value){ // used by login functions - gets a user id by meta value
	global $db;
	return $db->get_var($db->prepare("SELECT user FROM usermeta WHERE `key`=%s AND `value`=%s",$key,$value));
}

function is_set($set,$_func){ // checks to see if an action is set
	global $actions;
	foreach((array)$actions[$set] AS $priority)
		foreach((array)$priority AS $_the=>$function)
			if($_the==$_func)
				return true;
	return false;
}

function set_actions(){
	// set more actions here
	// add_action('login','some_function');
	add_action('new_image','upload_notification');
	add_action('view_image','log_hit');
}

function html_chars($string){ // cleans the string for html output
	return htmlentities(strip($string),ENT_QUOTES,'UTF-8');
}

function is_bot(){ // returns true if the visitor is a known bot
	$bots=array("msnbot-products","msnbot-media","ms search","msnbot","msn stealth","googlebot-image","googlebot/test","adsbot-google","mediapartners","gsa-crawler","feedfetcher","froogle","googlebot","google stealth","ask jeeves","askjeeves","teoma_agent","teomaagent","teoma","ask stealth","yahooseeker","yahoofeedseeker","yahoovideosearch","yahoo-mmcrawler","yahoo-mmaudvid","yahoo-blogs","yahoo! mindset","yahooysmcm","yahoo test","scooter","yahoo! slurp","slurp/cat","de slurp","slurp china","y!j-bsc","fast crawler","slurp@inktomi","slurp","inktomi","yahoo stealth","gigabot","netcraft","ia_archiver","fast-webcrawler","turnitinbot","technorati","findexa","nextlinks","findlinks","scooter","lycos","almaden.ibm","almaden","zyborg","infoseek","looksmart","martini","surveybot","overture","verticalcrawler","fastsearch","modspider","nameprotect","webfilter","robozilla","gais","gaisbo","zyborg","surveybot","bloglines","blogsearch","blogpulse","internetseer","sitecheck","markwatch","flunky","slysearch","aiderss","blogsearch","pubsub","pubsub","syndic8","userland","become.com","cowbot","yeti","naver","sogou","netcache","netapp","blogtick","baiduspider","toluu","simplepie","t-h-u-n-d-e-r-s-t-o-n-e","dtsearchspider","eidetica","fantom","girafa","grub.org","incywincy","sqworm","larbin","scoutabout","ubicrawler","webclipping","webrank","websquash","whizbang","cosmos","zealbot","semanticdiscovery","snapbot","thumbshots","virtual reach","wordpress/2.","yandex","linkcheck","idbot","id-search","nutch","heritrix","webalta","indy library","intelliseek","lnspiderguy","linkwalker","java/","wget/","libcurl","libwww","python-urllib","urllib","lwp-trivial","gt::www","snoopy","microsoft url control","http::lite","phpcrawl","uri::fetch","pecl::http","zend_http_client","http client","httpclient","parser","crawler","indexer","archiver","worm","spider","bot");
	$agent=strtolower($_SERVER['HTTP_USER_AGENT']);
	foreach($bots as $bot)
		if(!(strpos($agent,$bot)===false))
			return true;
	if(ereg("^(67\.195\.|74\.6\.)",$_SERVER['REMOTE_ADDR']))
		return true;
	elseif(ereg("^(65.5[2-5]\.)",$_SERVER['REMOTE_ADDR']))
		return true;
	return false;
}

add_action('start','set_actions');

do_action('start'); # do not remove this line
?>